package org.luis.security.recorder.ui;

import org.luis.security.recorder.main.LaunchProps;
import org.luis.security.recorder.main.VideoSource;
import org.luis.security.recorder.ui.util.Observable;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.MouseEvent;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;
import org.luis.security.recorder.main.Logger;
import org.luis.security.recorder.main.VideoManager;
import org.luis.security.recorder.main.VideoProcessor;
import org.luis.security.recorder.ui.util.ScheduledUpdate;
import org.luis.security.recorder.video.SwingRenderer;
import org.luis.security.recorder.video.api.StreamSource;

/**
 *
 * @author luis
 */
public class VideoPreview extends javax.swing.JPanel implements Logger {

	Window window;
	boolean showControls;

	Observable<VideoSource> source = new Observable<>();
	SwingRenderer render = new SwingRenderer();

	/**
	 * Creates new form VideoPreview
	 *
	 * @param window
	 */
	public VideoPreview(Window window, Observable<VideoSource> source) {
		initComponents();
		this.source = source;
		init(window);
	}

	private void init(Window window) {
		this.window = window;
		setupIcons();
		readParams();
		setupRenderer();

		source.addListener((n, o) -> {
			readParams();
			startStopVideoRender();
		});

	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPopupMenu1 = new javax.swing.JPopupMenu();
        chkVideo2 = new javax.swing.JCheckBoxMenuItem();
        chkAudio2 = new javax.swing.JCheckBoxMenuItem();
        jSeparator1 = new javax.swing.JPopupMenu.Separator();
        btnOptions2 = new javax.swing.JMenuItem();
        btnTrash2 = new javax.swing.JMenuItem();
        btnFull2 = new javax.swing.JMenuItem();
        panelOptions = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        chkVideo1 = new javax.swing.JToggleButton();
        chkAudio1 = new javax.swing.JToggleButton();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(32767, 0));
        filler4 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(32767, 0));
        btnOptions1 = new javax.swing.JButton();
        filler2 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(32767, 0));
        filler3 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(32767, 0));
        btnTrash = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        btnFull = new javax.swing.JButton();
        videoPreview = new javax.swing.JPanel();

        chkVideo2.setSelected(true);
        chkVideo2.setText("Video");
        chkVideo2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkVideo2ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(chkVideo2);

        chkAudio2.setSelected(true);
        chkAudio2.setText("Audio");
        chkAudio2.setEnabled(false);
        chkAudio2.setFocusable(true);
        chkAudio2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkAudio2ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(chkAudio2);
        jPopupMenu1.add(jSeparator1);

        btnOptions2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/icons/control_16.png"))); // NOI18N
        btnOptions2.setText("Options");
        btnOptions2.setToolTipText("");
        btnOptions2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOptions2ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(btnOptions2);

        btnTrash2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/icons/trash_16.png"))); // NOI18N
        btnTrash2.setText("Remove");
        btnTrash2.setToolTipText("");
        btnTrash2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnTrash2ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(btnTrash2);

        btnFull2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/icons/fullsc_16.png"))); // NOI18N
        btnFull2.setText("Full");
        btnFull2.setToolTipText("");
        btnFull2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnFull2ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(btnFull2);

        setBorder(javax.swing.BorderFactory.createLineBorder(LaunchProps.useLightTheme.get()?Color.LIGHT_GRAY:Color.BLACK));
        setMinimumSize(new java.awt.Dimension(100, 130));
        addHierarchyListener(new java.awt.event.HierarchyListener() {
            public void hierarchyChanged(java.awt.event.HierarchyEvent evt) {
                formHierarchyChanged(evt);
            }
        });
        addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                formMouseReleased(evt);
            }
        });

        panelOptions.setMinimumSize(new java.awt.Dimension(551, 43));

        chkVideo1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/icons/video_16.png"))); // NOI18N
        chkVideo1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkVideo1ActionPerformed(evt);
            }
        });
        jPanel1.add(chkVideo1);

        chkAudio1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/icons/sound_16.png"))); // NOI18N
        chkAudio1.setEnabled(false);
        chkAudio1.setFocusable(false);
        chkAudio1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkAudio1ActionPerformed(evt);
            }
        });
        jPanel1.add(chkAudio1);
        jPanel1.add(filler1);
        jPanel1.add(filler4);

        btnOptions1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/icons/control_16.png"))); // NOI18N
        btnOptions1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOptions1ActionPerformed(evt);
            }
        });
        jPanel1.add(btnOptions1);
        jPanel1.add(filler2);
        jPanel1.add(filler3);

        btnTrash.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/icons/trash_16.png"))); // NOI18N
        btnTrash.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnTrashActionPerformed(evt);
            }
        });
        jPanel1.add(btnTrash);

        jPanel2.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

        btnFull.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/icons/fullsc_16.png"))); // NOI18N
        btnFull.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnFullActionPerformed(evt);
            }
        });
        jPanel2.add(btnFull);

        javax.swing.GroupLayout panelOptionsLayout = new javax.swing.GroupLayout(panelOptions);
        panelOptions.setLayout(panelOptionsLayout);
        panelOptionsLayout.setHorizontalGroup(
            panelOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, panelOptionsLayout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, 60, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        panelOptionsLayout.setVerticalGroup(
            panelOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );

        videoPreview.setBackground(new java.awt.Color(153, 153, 153));
        videoPreview.setLayout(new java.awt.BorderLayout());

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(panelOptions, javax.swing.GroupLayout.PREFERRED_SIZE, 370, Short.MAX_VALUE)
            .addComponent(videoPreview, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(panelOptions, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(videoPreview, javax.swing.GroupLayout.DEFAULT_SIZE, 231, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void btnOptions1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOptions1ActionPerformed
		showConfigDialog();
    }//GEN-LAST:event_btnOptions1ActionPerformed

    private void formHierarchyChanged(java.awt.event.HierarchyEvent evt) {//GEN-FIRST:event_formHierarchyChanged
		startStopVideoRender();
		startStopAudio();
    }//GEN-LAST:event_formHierarchyChanged

    private void chkVideo2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkVideo2ActionPerformed
		source.get().videoPreview = chkVideo2.isSelected();
		readParams();
		notifySourceUpdated();
    }//GEN-LAST:event_chkVideo2ActionPerformed

    private void formMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseReleased
		maybeShowPopup(evt);
    }//GEN-LAST:event_formMouseReleased

    private void chkAudio2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkAudio2ActionPerformed
		source.get().audioPreview = chkAudio2.isSelected();
		readParams();
		notifySourceUpdated();
    }//GEN-LAST:event_chkAudio2ActionPerformed

    private void btnOptions2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOptions2ActionPerformed
		showConfigDialog();
    }//GEN-LAST:event_btnOptions2ActionPerformed

    private void btnTrashActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnTrashActionPerformed
		confirmToRemove();
    }//GEN-LAST:event_btnTrashActionPerformed

    private void btnTrash2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnTrash2ActionPerformed
		confirmToRemove();
    }//GEN-LAST:event_btnTrash2ActionPerformed

    private void chkVideo1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkVideo1ActionPerformed
		source.get().videoPreview = chkVideo1.isSelected();
		readParams();
		notifySourceUpdated();
    }//GEN-LAST:event_chkVideo1ActionPerformed

    private void chkAudio1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkAudio1ActionPerformed
		source.get().audioPreview = chkAudio1.isSelected();
		readParams();
		notifySourceUpdated();
    }//GEN-LAST:event_chkAudio1ActionPerformed

    private void btnFullActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnFullActionPerformed
		window.setToogleFullPreview(this);
    }//GEN-LAST:event_btnFullActionPerformed

    private void btnFull2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnFull2ActionPerformed
		window.setToogleFullPreview(this);
    }//GEN-LAST:event_btnFull2ActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnFull;
    private javax.swing.JMenuItem btnFull2;
    private javax.swing.JButton btnOptions1;
    private javax.swing.JMenuItem btnOptions2;
    private javax.swing.JButton btnTrash;
    private javax.swing.JMenuItem btnTrash2;
    private javax.swing.JToggleButton chkAudio1;
    private javax.swing.JCheckBoxMenuItem chkAudio2;
    private javax.swing.JToggleButton chkVideo1;
    private javax.swing.JCheckBoxMenuItem chkVideo2;
    private javax.swing.Box.Filler filler1;
    private javax.swing.Box.Filler filler2;
    private javax.swing.Box.Filler filler3;
    private javax.swing.Box.Filler filler4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPopupMenu jPopupMenu1;
    private javax.swing.JPopupMenu.Separator jSeparator1;
    private javax.swing.JPanel panelOptions;
    private javax.swing.JPanel videoPreview;
    // End of variables declaration//GEN-END:variables

	@Override
	public void setSize(Dimension d) {
		super.setSize(d);
		if (d == null) {
			return;
		}
		updateControlVisibility();
	}

	private boolean amIVisible() {
		Container c = getParent();
		while (c != null) {
			if (!c.isVisible()) {
				return false;
			} else {
				c = c.getParent();
			}
		}
		return true;
	}

	private void startStopVideoRender() {
		if (amIVisible() && source.get().videoPreview) {
			startRenderingSource();
		} else {
			stopRenderingSource();
		}
	}

	private void setupRenderer() {
		// Create a Swing video display component
		videoPreview.add(render);

		// Create a level component and set it as the audio-filter property
		// on the playbin - this will post audio level messages to the bus -
		SwingUtilities.invokeLater(() -> {
			videoPreview.revalidate();
		});
	}

	private void startRenderingSource() {
		// Ensure that we dont listening video.
		stopRenderingSource();

		VideoManager manager = VideoManager.getInstance();
		VideoProcessor processor = manager.getVideoProcessor(source.get());

		if (processor == null) {
			error("No processor for source: " + source.get().id);
			return;
		}

		// Start listening
		StreamSource streamer = processor.getStreamSource();
		streamer.connect(render);
	}

	private void stopRenderingSource() {

		VideoManager manager = VideoManager.getInstance();
		VideoProcessor processor = manager.getVideoProcessor(source.get());

		if (processor == null) {
			error("No processor for source: " + source.get().id);
			return;
		}

		StreamSource stream = processor.getStreamSource();
		stream.disconnect(render);
	}

	private void readParams() {
		chkVideo1.setSelected(source.get().videoPreview);
		chkAudio1.setSelected(source.get().audioPreview && source.get().videoPreview);
		chkVideo2.setSelected(source.get().videoPreview);
		chkAudio2.setSelected(source.get().audioPreview && source.get().videoPreview);
	}

	private void startStopAudio() {
		if (amIVisible() && source.get().videoPreview && source.get().audioPreview) {
//			startListeningAudio();
		} else {
//			stopListeningAudio();
		}
	}

	private void notifySourceUpdated() {
		ScheduledUpdate.getInstance().schedule("video-preview-source-update", 200l, () -> {
			source.forceNotify();
		});
	}

	private void maybeShowPopup(MouseEvent e) {
		if (e.getButton() == MouseEvent.BUTTON3) {
			jPopupMenu1.show(e.getComponent(),
					e.getX(), e.getY());
		}
	}

	void setShowControls(boolean show) {
		showControls = show;
		updateControlVisibility();
	}

	private void showConfigDialog() {
		DialogViewConfiguration dialog = new DialogViewConfiguration(window, source);
		dialog.setVisible(true);

		if (dialog.isAccepted()) {
			readParams();
			notifySourceUpdated();
			startStopVideoRender();
		}
	}

	private void updateControlVisibility() {
		panelOptions.setVisible(getSize().width > 250 && showControls);
	}

	private void markToDelete() {
		source.get().markedToRemove = true;
		source.get().audioPreview = false;
		source.get().videoPreview = false;
		readParams();
		stopRenderingSource();
		notifySourceUpdated();
//		stopListeningAudio();
	}

	private void confirmToRemove() {
		int conf = JOptionPane.showConfirmDialog(this, "Remove this camera?", "Warning", JOptionPane.OK_CANCEL_OPTION);
		if (JOptionPane.OK_OPTION == conf) {
			markToDelete();
		}
	}

	private void setupIcons() {
		FileManager manager = FileManager.getInstance();

		chkVideo1.setIcon(manager.getIcon("video"));
		chkVideo2.setIcon(chkVideo1.getIcon());
		chkAudio1.setIcon(manager.getIcon("sound"));
		chkAudio2.setIcon(chkAudio1.getIcon());
		btnOptions1.setIcon(manager.getIcon("control"));
		btnOptions2.setIcon(btnOptions1.getIcon());
		btnTrash.setIcon(manager.getIcon("trash"));
		btnTrash2.setIcon(btnTrash.getIcon());
		btnFull.setIcon(manager.getIcon("fullsc"));
		btnFull2.setIcon(manager.getIcon("fullsc"));

	}

}
